Index: src/Actions/GlobalListOfActions.hpp
===================================================================
--- src/Actions/GlobalListOfActions.hpp	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ src/Actions/GlobalListOfActions.hpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -171,4 +171,5 @@
   (WorldSetBoundaryConditions) \
   (WorldSetDefaultName) \
+  (WorldSetThermostat) \
   (WorldSetWorldTime) \
   (WorldStepWorldTime)
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ src/Actions/Makefile.am	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -642,4 +642,5 @@
   Actions/WorldAction/SetBoundaryConditionsAction.cpp \
   Actions/WorldAction/SetDefaultNameAction.cpp \
+  Actions/WorldAction/SetThermostatAction.cpp \
   Actions/WorldAction/SetWorldTimeAction.cpp \
   Actions/WorldAction/StepWorldTimeAction.cpp
@@ -657,4 +658,5 @@
   Actions/WorldAction/SetBoundaryConditionsAction.hpp \
   Actions/WorldAction/SetDefaultNameAction.hpp \
+  Actions/WorldAction/SetThermostatAction.hpp \
   Actions/WorldAction/SetWorldTimeAction.hpp \
   Actions/WorldAction/StepWorldTimeAction.hpp
@@ -672,4 +674,5 @@
   Actions/WorldAction/SetBoundaryConditionsAction.def \
   Actions/WorldAction/SetDefaultNameAction.def \
+  Actions/WorldAction/SetThermostatAction.def \
   Actions/WorldAction/SetWorldTimeAction.def \
   Actions/WorldAction/StepWorldTimeAction.def
Index: src/Actions/WorldAction/SetThermostatAction.cpp
===================================================================
--- src/Actions/WorldAction/SetThermostatAction.cpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ src/Actions/WorldAction/SetThermostatAction.cpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,97 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * SetThermostatAction.cpp
+ *
+ *  Created on: Jul 12, 2017
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "Parser/FormatParserStorage.hpp"
+#include "Parser/ChangeTracker.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+#include <boost/filesystem/fstream.hpp>
+
+#include "Actions/WorldAction/SetThermostatAction.hpp"
+
+#include "Thermostats/ThermoStatContainer.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "SetThermostatAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr WorldSetThermostatAction::performCall()
+{
+  LOG(1, "Setting active thermostat to " << params.thermostat.get() << ".");
+
+  ThermoStatContainer * container = World::getInstance().getThermostats();
+
+  const std::string oldname = container->getActive()->name();
+  WorldSetThermostatState *undoState = new WorldSetThermostatState(oldname, params);
+
+//  container->makeActive(params.thermostat.get());
+
+  return ActionState::ptr(undoState);
+}
+
+ActionState::ptr WorldSetThermostatAction::performUndo(ActionState::ptr _state)
+{
+  WorldSetThermostatState *state = assert_cast<WorldSetThermostatState*>(_state.get());
+  LOG(1, "Setting active thermostat back to " << state->oldname << ".");
+//  container->makeActive(state->oldname);
+
+  return ActionState::ptr(_state);
+}
+
+ActionState::ptr WorldSetThermostatAction::performRedo(ActionState::ptr _state)
+{
+  WorldSetThermostatState *state = assert_cast<WorldSetThermostatState*>(_state.get());
+  LOG(1, "Setting active thermostat again to " << params.thermostat.get() << ".");
+//  container->makeActive(params.thermostat.get());
+
+  return ActionState::ptr(_state);
+}
+
+bool WorldSetThermostatAction::canUndo() {
+  return true;
+}
+
+bool WorldSetThermostatAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/SetThermostatAction.def
===================================================================
--- src/Actions/WorldAction/SetThermostatAction.def	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ src/Actions/WorldAction/SetThermostatAction.def	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,35 @@
+/*
+ * SetThermostatAction.def
+ *
+ *  Created on: Jul 12, 2017
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/ThermostatValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::string)
+#define paramtokens ("set-thermostat")
+#define paramdescriptions ("name of the thermostat")
+#undef paramdefaults
+#define paramreferences (thermostat)
+#define paramvalids \
+(ThermostatValidator())
+
+#define statetypes (std::string)
+#define statereferences (oldname)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define MENUNAME "world"
+#define MENUPOSITION 10
+#define ACTIONNAME SetThermostat
+#define TOKEN "set-thermostat"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "set the active thermostat to use for molecular dynamics"
+#undef SHORTFORM
Index: src/Actions/WorldAction/SetThermostatAction.hpp
===================================================================
--- src/Actions/WorldAction/SetThermostatAction.hpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ src/Actions/WorldAction/SetThermostatAction.hpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,22 @@
+/*
+ * SetThermostatAction.hpp
+ *
+ *  Created on: Jul 12, 2017
+ *      Author: heber
+ */
+
+#ifndef SETTHERMOSTATACTION_HPP_
+#define SETTHERMOSTATACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "SetThermostatAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* SETTHERMOSTATACTION_HPP_ */
Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ src/Parameters/Makefile.am	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -32,4 +32,5 @@
 	Parameters/Validators/Specific/ShapeOpValidator.cpp \
 	Parameters/Validators/Specific/ShapeTypeValidator.cpp \
+	Parameters/Validators/Specific/ThermostatValidator.cpp \
 	Parameters/Validators/Specific/TimeStepPresentValidator.cpp \
 	Parameters/Validators/Specific/VectorNotZeroValidator.cpp \
@@ -94,4 +95,5 @@
 	Parameters/Validators/Specific/ShapeOpValidator.hpp \
 	Parameters/Validators/Specific/ShapeTypeValidator.hpp \
+	Parameters/Validators/Specific/ThermostatValidator.hpp \
 	Parameters/Validators/Specific/TimeStepPresentValidator.hpp \
 	Parameters/Validators/Specific/VectorNotZeroValidator.hpp \
Index: src/Parameters/Validators/Specific/ThermostatValidator.cpp
===================================================================
--- src/Parameters/Validators/Specific/ThermostatValidator.cpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ src/Parameters/Validators/Specific/ThermostatValidator.cpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,56 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2017 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * ThermostatValidator.cpp
+ *
+ *  Created on: Jul 12, 2017
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//#include "CodePatterns/MemDebug.hpp"
+
+#include "ThermostatValidator.hpp"
+
+#include "Thermostats/ThermoStatContainer.hpp"
+#include "World.hpp"
+
+ThermostatValidator::ThermostatValidator() :
+DiscreteValidator<std::string>(std::vector<std::string>())
+{
+  // add all names from factory
+  const ThermoStatContainer &container = *World::getInstance().getThermostats();
+  for (ThermoStatContainer::traitsMap::const_iterator t = container.availThermostats.begin();
+      t != container.availThermostats.end(); ++ t) {
+    appendValidValue(t->first);
+  }
+}
+
+
+
+
Index: src/Parameters/Validators/Specific/ThermostatValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/ThermostatValidator.hpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ src/Parameters/Validators/Specific/ThermostatValidator.hpp	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,31 @@
+/*
+ * ThermostatValidator.hpp
+ *
+ *  Created on: Jul 12, 2017
+ *      Author: heber
+ */
+
+#ifndef THERMOSTATVALIDATOR_HPP_
+#define THERMOSTATVALIDATOR_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string>
+
+#include "Parameters/Validators/DiscreteValidator.hpp"
+
+/** This validator checks whether the given string refers to a valid
+ * \ref FormatParser type.
+ */
+class ThermostatValidator : public DiscreteValidator<std::string>
+{
+public:
+  ThermostatValidator();
+};
+
+
+#endif /* THERMOSTATVALIDATOR_HPP_ */
Index: tests/Python/AllActions/options.dat
===================================================================
--- tests/Python/AllActions/options.dat	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ tests/Python/AllActions/options.dat	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -228,4 +228,5 @@
 set-random-number-distribution	"uniform_int"
 set-random-number-engine	"lagged_fibonacci607"
+set-thermostat	"berendsen"
 set-threshold	"1e-6"
 set-tremolo-atomdata	"ATOMDATA type id x=3"
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ tests/regression/Makefile.am	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -170,4 +170,5 @@
 	$(srcdir)/Options/Session/testsuite-options-store-session-python.at \
 	$(srcdir)/Options/SetDefaultName/testsuite-options-set-default-name.at \
+	$(srcdir)/Options/Thermostat/testsuite-options-thermostat.at \
 	$(srcdir)/Options/Verbosity/testsuite-options-verbosity.at \
 	$(srcdir)/Options/Warranty/testsuite-options-warranty.at \
Index: tests/regression/Options/Thermostat/testsuite-options-thermostat.at
===================================================================
--- tests/regression/Options/Thermostat/testsuite-options-thermostat.at	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
+++ tests/regression/Options/Thermostat/testsuite-options-thermostat.at	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -0,0 +1,47 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### setting thermostat
+
+AT_SETUP([Standard Options - setting thermostat])
+AT_KEYWORDS([options verbose])
+AT_XFAIL_IF([/bin/true])
+
+AT_CHECK([../../molecuilder --set-thermostat "berendsen"], 0, [stdout], [ignore])
+AT_CHECK([grep "Setting active thermostat.*to berendsen" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Standard Options - setting thermostat with Undo])
+AT_KEYWORDS([options verbose undo])
+AT_XFAIL_IF([/bin/true])
+
+AT_CHECK([../../molecuilder --set-thermostat "berendsen" --undo], 0, [stdout], [ignore])
+AT_CHECK([grep "Setting active thermostat.*to none" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Standard Options - setting thermostat with Redo])
+AT_KEYWORDS([options verbose redo])
+AT_XFAIL_IF([/bin/true])
+
+AT_CHECK([../../molecuilder --set-thermostat "berendsen" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([grep "Setting active thermostat.*to berendsen" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Options/testsuite-options.at
===================================================================
--- tests/regression/Options/testsuite-options.at	(revision c837db7379c954077d4efb8b85fa76ac56a84cda)
+++ tests/regression/Options/testsuite-options.at	(revision bc4be2a42d112f64e561fc2f3ba293f76e2710f9)
@@ -55,2 +55,5 @@
 m4_include([Options/DryRun/testsuite-options-no-dryrun.at])
 m4_include([Options/DryRun/testsuite-options-dryrun-storesession.at])
+
+# checking thermostat
+m4_include([Options/Thermostat/testsuite-options-thermostat.at])
